# rest_api

RestApi - JavaScript client for rest_api
This is the API by greeting service.  nCreated at: 2017/12/28 19:06:06 UTC  Git HEAD: null
This SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.languages.JavascriptClientCodegen

## Installation

### For [Node.js](https://nodejs.org/)

#### npm

To publish the library as a [npm](https://www.npmjs.com/),
please follow the procedure in ["Publishing npm packages"](https://docs.npmjs.com/getting-started/publishing-npm-packages).

Then install it via:

```shell
npm install rest_api --save
```

##### Local development

To use the library locally without publishing to a remote npm registry, first install the dependencies by changing 
into the directory containing `package.json` (and this README). Let's call this `JAVASCRIPT_CLIENT_DIR`. Then run:

```shell
npm install
```

Next, [link](https://docs.npmjs.com/cli/link) it globally in npm with the following, also from `JAVASCRIPT_CLIENT_DIR`:

```shell
npm link
```

Finally, switch to the directory you want to use your rest_api from, and run:

```shell
npm link /path/to/<JAVASCRIPT_CLIENT_DIR>
```

You should now be able to `require('rest_api')` in javascript files from the directory you ran the last 
command above from.

#### git
#
If the library is hosted at a git repository, e.g.
https://github.com/GIT_USER_ID/GIT_REPO_ID
then install it via:

```shell
    npm install GIT_USER_ID/GIT_REPO_ID --save
```

### For browser

The library also works in the browser environment via npm and [browserify](http://browserify.org/). After following
the above steps with Node.js and installing browserify with `npm install -g browserify`,
perform the following (assuming *main.js* is your entry file, that's to say your javascript file where you actually 
use this library):

```shell
browserify main.js > bundle.js
```

Then include *bundle.js* in the HTML pages.

### Webpack Configuration

Using Webpack you may encounter the following error: "Module not found: Error:
Cannot resolve module", most certainly you should disable AMD loader. Add/merge
the following section to your webpack config:

```javascript
module: {
  rules: [
    {
      parser: {
        amd: false
      }
    }
  ]
}
```

## Getting Started

Please follow the [installation](#installation) instruction and execute the following JS code:

```javascript
var RestApi = require('rest_api');

var api = new RestApi.GreetingApi()

var dto = new RestApi.GreetingInDTO(); // {GreetingInDTO} dto


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
api.createGreeting(dto, callback);

```

## Documentation for API Endpoints

All URIs are relative to *https://localhost:9090*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*RestApi.GreetingApi* | [**createGreeting**](docs/GreetingApi.md#createGreeting) | **POST** /greetings | Create a greeting
*RestApi.GreetingApi* | [**deleteGreetingById**](docs/GreetingApi.md#deleteGreetingById) | **DELETE** /greetings/{id} | Delete a greeting
*RestApi.GreetingApi* | [**readAllGreetings**](docs/GreetingApi.md#readAllGreetings) | **GET** /greetings | Read all greetings
*RestApi.GreetingApi* | [**readGreetingById**](docs/GreetingApi.md#readGreetingById) | **GET** /greetings/{id} | Read a greeting
*RestApi.GreetingApi* | [**updateGreeting**](docs/GreetingApi.md#updateGreeting) | **PUT** /greetings/{id} | Update a greeting
*RestApi.PersonApi* | [**readAllPeople**](docs/PersonApi.md#readAllPeople) | **GET** /people | Read all people
*RestApi.PersonApi* | [**readPersonByEmail**](docs/PersonApi.md#readPersonByEmail) | **GET** /people/{email} | Read a person detail


## Documentation for Models

 - [RestApi.Greeting](docs/Greeting.md)
 - [RestApi.GreetingInDTO](docs/GreetingInDTO.md)
 - [RestApi.Person](docs/Person.md)


## Documentation for Authorization

 All endpoints do not require authorization.

