# RestApi.GreetingApi

All URIs are relative to *https://localhost:9090*

Method | HTTP request | Description
------------- | ------------- | -------------
[**createGreeting**](GreetingApi.md#createGreeting) | **POST** /greetings | Create a greeting
[**deleteGreetingById**](GreetingApi.md#deleteGreetingById) | **DELETE** /greetings/{id} | Delete a greeting
[**readAllGreetings**](GreetingApi.md#readAllGreetings) | **GET** /greetings | Read all greetings
[**readGreetingById**](GreetingApi.md#readGreetingById) | **GET** /greetings/{id} | Read a greeting
[**updateGreeting**](GreetingApi.md#updateGreeting) | **PUT** /greetings/{id} | Update a greeting


<a name="createGreeting"></a>
# **createGreeting**
> Greeting createGreeting(dto)

Create a greeting

### Example
```javascript
var RestApi = require('rest_api');

var apiInstance = new RestApi.GreetingApi();

var dto = new RestApi.GreetingInDTO(); // GreetingInDTO | dto


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.createGreeting(dto, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **dto** | [**GreetingInDTO**](GreetingInDTO.md)| dto | 

### Return type

[**Greeting**](Greeting.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: */*

<a name="deleteGreetingById"></a>
# **deleteGreetingById**
> Greeting deleteGreetingById(id)

Delete a greeting

### Example
```javascript
var RestApi = require('rest_api');

var apiInstance = new RestApi.GreetingApi();

var id = 789; // Number | id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.deleteGreetingById(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **Number**| id | 

### Return type

[**Greeting**](Greeting.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: */*

<a name="readAllGreetings"></a>
# **readAllGreetings**
> [Greeting] readAllGreetings()

Read all greetings

### Example
```javascript
var RestApi = require('rest_api');

var apiInstance = new RestApi.GreetingApi();

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.readAllGreetings(callback);
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**[Greeting]**](Greeting.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="readGreetingById"></a>
# **readGreetingById**
> Greeting readGreetingById(id)

Read a greeting

### Example
```javascript
var RestApi = require('rest_api');

var apiInstance = new RestApi.GreetingApi();

var id = 789; // Number | id


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.readGreetingById(id, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **Number**| id | 

### Return type

[**Greeting**](Greeting.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: */*

<a name="updateGreeting"></a>
# **updateGreeting**
> Greeting updateGreeting(greeting)

Update a greeting

### Example
```javascript
var RestApi = require('rest_api');

var apiInstance = new RestApi.GreetingApi();

var greeting = new RestApi.GreetingInDTO(); // GreetingInDTO | greeting


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.updateGreeting(greeting, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **greeting** | [**GreetingInDTO**](GreetingInDTO.md)| greeting | 

### Return type

[**Greeting**](Greeting.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: */*

