# RestApi.PersonApi

All URIs are relative to *https://localhost:9090*

Method | HTTP request | Description
------------- | ------------- | -------------
[**readAllPeople**](PersonApi.md#readAllPeople) | **GET** /people | Read all people
[**readPersonByEmail**](PersonApi.md#readPersonByEmail) | **GET** /people/{email} | Read a person detail


<a name="readAllPeople"></a>
# **readAllPeople**
> [Person] readAllPeople()

Read all people

### Example
```javascript
var RestApi = require('rest_api');

var apiInstance = new RestApi.PersonApi();

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.readAllPeople(callback);
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**[Person]**](Person.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="readPersonByEmail"></a>
# **readPersonByEmail**
> Person readPersonByEmail(email)

Read a person detail

### Example
```javascript
var RestApi = require('rest_api');

var apiInstance = new RestApi.PersonApi();

var email = "email_example"; // String | email


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.readPersonByEmail(email, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **email** | **String**| email | 

### Return type

[**Person**](Person.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: */*

