/**
 * REST API
 * This is the API by greeting service.  nCreated at: 2017/12/28 19:06:06 UTC  Git HEAD: null
 *
 * OpenAPI spec version: 1.0.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Greeting', 'model/GreetingInDTO'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/Greeting'), require('../model/GreetingInDTO'));
  } else {
    // Browser globals (root is window)
    if (!root.RestApi) {
      root.RestApi = {};
    }
    root.RestApi.GreetingApi = factory(root.RestApi.ApiClient, root.RestApi.Greeting, root.RestApi.GreetingInDTO);
  }
}(this, function(ApiClient, Greeting, GreetingInDTO) {
  'use strict';

  /**
   * Greeting service.
   * @module api/GreetingApi
   * @version 1.0.0
   */

  /**
   * Constructs a new GreetingApi. 
   * @alias module:api/GreetingApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the createGreeting operation.
     * @callback module:api/GreetingApi~createGreetingCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Greeting} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create a greeting
     * @param {module:model/GreetingInDTO} dto dto
     * @param {module:api/GreetingApi~createGreetingCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/Greeting}
     */
    this.createGreeting = function(dto, callback) {
      var postBody = dto;

      // verify the required parameter 'dto' is set
      if (dto === undefined || dto === null) {
        throw new Error("Missing the required parameter 'dto' when calling createGreeting");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['*/*'];
      var returnType = Greeting;

      return this.apiClient.callApi(
        '/greetings', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the deleteGreetingById operation.
     * @callback module:api/GreetingApi~deleteGreetingByIdCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Greeting} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete a greeting
     * @param {Number} id id
     * @param {module:api/GreetingApi~deleteGreetingByIdCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/Greeting}
     */
    this.deleteGreetingById = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling deleteGreetingById");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['*/*'];
      var returnType = Greeting;

      return this.apiClient.callApi(
        '/greetings/{id}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the readAllGreetings operation.
     * @callback module:api/GreetingApi~readAllGreetingsCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Greeting>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Read all greetings
     * @param {module:api/GreetingApi~readAllGreetingsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/Greeting>}
     */
    this.readAllGreetings = function(callback) {
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = [Greeting];

      return this.apiClient.callApi(
        '/greetings', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the readGreetingById operation.
     * @callback module:api/GreetingApi~readGreetingByIdCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Greeting} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Read a greeting
     * @param {Number} id id
     * @param {module:api/GreetingApi~readGreetingByIdCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/Greeting}
     */
    this.readGreetingById = function(id, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling readGreetingById");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['*/*'];
      var returnType = Greeting;

      return this.apiClient.callApi(
        '/greetings/{id}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateGreeting operation.
     * @callback module:api/GreetingApi~updateGreetingCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Greeting} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update a greeting
     * @param {module:model/GreetingInDTO} greeting greeting
     * @param {module:api/GreetingApi~updateGreetingCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/Greeting}
     */
    this.updateGreeting = function(greeting, callback) {
      var postBody = greeting;

      // verify the required parameter 'greeting' is set
      if (greeting === undefined || greeting === null) {
        throw new Error("Missing the required parameter 'greeting' when calling updateGreeting");
      }


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['*/*'];
      var returnType = Greeting;

      return this.apiClient.callApi(
        '/greetings/{id}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
